Index: trunk/gui/scripts/animover.tcl
===================================================================
--- trunk/gui/scripts/animover.tcl	(revision 6716)
+++ trunk/gui/scripts/animover.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: animover - animated move
@@ -8,8 +7,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
@@ -32,5 +28,5 @@
 
     constructor {args} { # defined below }
-
+                                                                                
     protected method _redraw {}
     protected variable _x0 0   ;# min value for middle image
@@ -51,5 +47,5 @@
         [file join $dir images bgr.gif]]
 }
-
+                                                                                
 itk::usual Animover {
 }
Index: trunk/gui/scripts/combobox.tcl
===================================================================
--- trunk/gui/scripts/combobox.tcl	(revision 6716)
+++ trunk/gui/scripts/combobox.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: combobox - entry widget with a drop-down list of values
@@ -10,8 +9,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
@@ -24,7 +20,5 @@
 option add *Combobox.textBackground white widgetDefault
 option add *Combobox.textForeground black widgetDefault
-option add *Combobox.disabledBackground white widgetDefault
-option add *Combobox.disabledForeground gray widgetDefault
-option add *Combobox.font -*-helvetica-medium-r-normal-*-12-* widgetDefault
+option add *Combobox.font -*-helvetica-medium-r-normal-*-*-120-* widgetDefault
 
 itcl::class Rappture::Combobox {
@@ -32,21 +26,14 @@
 
     itk_option define -editable editable Editable ""
-    itk_option define -state state State "normal"
     itk_option define -width width Width 0
-    itk_option define -disabledbackground disabledBackground DisabledBackground ""
-    itk_option define -disabledforeground disabledForeground DisabledForeground ""
-    itk_option define -interactcommand interactCommand InteractCommand ""
 
     constructor {args} { # defined below }
 
     public method value {args}
-    public method translate {value {defValue ""}}
-    public method label {value}
-    public method current {}
+    public method translate {value}
     public method choices {option args}
 
     protected method _entry {option}
     protected method _dropdown {option}
-    protected method _fixState {}
 
     blt::bitmap define ComboboxArrow {
@@ -56,8 +43,6 @@
            0xfe, 0x7c, 0x38, 0x10};
     }
-    private variable _value2label
-    private variable _label2value
-}
-
+}
+                                                                                
 itk::usual Combobox {
     keep -cursor -font
@@ -136,5 +121,5 @@
         }
 
-        after 10 [list catch [list event generate $itk_component(hull) <<Value>>]]
+        event generate $itk_component(hull) <<Value>>
     } elseif {[llength $args] != 0} {
         error "wrong # args: should be \"value ?newval?\""
@@ -151,41 +136,11 @@
 # method returns the corresponding value.  Otherwise, it returns "".
 # ----------------------------------------------------------------------
-itcl::body Rappture::Combobox::translate {value {defValue ""}} {
+itcl::body Rappture::Combobox::translate {value} {
     foreach {val label} [choices get -both] {
-        if {$label eq $value} {
+        if {$label == $value} {
             return $val
         }
     }
-    return $defValue
-}
-
-# ----------------------------------------------------------------------
-# USAGE: label <value>
-#
-# Clients use this to translate a value to a label.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Combobox::label { myValue } {
-    foreach {val label} [choices get -both] {
-        if {$myValue == $val} {
-            return $label
-        }
-    }
     return ""
-}
-
-# ----------------------------------------------------------------------
-# USAGE: current
-#
-# Clients use this to retrieve a label from the entry widget and return
-# its value, if one exists. If no value exists for the label, then the
-# label is returned.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Combobox::current {} {
-    set raw [$itk_component(entry) get]
-    set value [translate $raw "badValue"]
-    if { $value ne "badValue" } {
-        return $value
-    }
-    return $raw
 }
 
@@ -219,13 +174,10 @@
     switch -- $option {
         apply {
-            if {$itk_option(-editable) && $itk_option(-state) == "normal"} {
+            if {$itk_option(-editable)} {
                 event generate $itk_component(hull) <<Value>>
-                if {[string length $itk_option(-interactcommand)] > 0} {
-                    uplevel #0 $itk_option(-interactcommand)
-                }
             }
         }
         click {
-            if {!$itk_option(-editable) && $itk_option(-state) == "normal"} {
+            if {!$itk_option(-editable)} {
                 $itk_component(button) configure -relief sunken
                 update idletasks; after 100
@@ -268,56 +220,11 @@
         }
         select {
-            set newval [$itk_component(ddlist) current -label]
-            set val [$itk_component(entry) get]
-            if {$newval ne "" && $newval ne $val} {
-                value $newval
-                if {[string length $itk_option(-interactcommand)] > 0} {
-                    uplevel #0 $itk_option(-interactcommand)
-                }
+            set val [$itk_component(ddlist) current -label]
+            if {"" != $val} {
+                value $val
             }
         }
         default {
             error "bad option \"$option\": should be post, unpost, select"
-        }
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _fixState
-#
-# Used internally to fix the widget state when the -editable/-state
-# options change.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Combobox::_fixState {} {
-    if {$itk_option(-state) == "normal"} {
-        $itk_component(button) configure -state normal
-        $itk_component(entry) configure \
-            -background $itk_option(-textbackground) \
-            -foreground $itk_option(-textforeground) \
-            -disabledbackground $itk_option(-textbackground) \
-            -disabledforeground $itk_option(-textforeground)
-    } else {
-        $itk_component(button) configure -state disabled
-        $itk_component(entry) configure \
-            -background $itk_option(-disabledbackground) \
-            -foreground $itk_option(-disabledforeground) \
-            -disabledbackground $itk_option(-disabledbackground) \
-            -disabledforeground $itk_option(-disabledforeground)
-    }
-
-    if {$itk_option(-editable)} {
-        if {$itk_option(-state) == "normal"} {
-            $itk_component(entry) configure -state normal
-        } else {
-            $itk_component(entry) configure -state disabled
-        }
-    } else {
-        $itk_component(entry) configure -state disabled
-    }
-
-    if {!$itk_option(-editable) || $itk_option(-state) != "normal"} {
-        # can't keep focus here -- move it along to the next widget
-        if {[focus] == $itk_component(entry)} {
-            focus [tk_focusNext [focus]]
         }
     }
@@ -331,15 +238,11 @@
         error "bad value \"$itk_option(-editable)\": should be boolean"
     }
-    _fixState
-}
-
-# ----------------------------------------------------------------------
-# CONFIGURATION OPTION: -state
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Combobox::state {
-    set valid {normal disabled}
-    if {[lsearch -exact $valid $itk_option(-state)] < 0} {
-        error "bad value \"$itk_option(-state)\": should be [join $valid {, }]"
-    }
-    _fixState
-}
+    if {$itk_option(-editable)} {
+        $itk_component(entry) configure -state normal
+    } else {
+        $itk_component(entry) configure -state disabled
+        if {[focus] == $itk_component(entry)} {
+            focus [tk_focusNext [focus]]
+        }
+    }
+}
Index: trunk/gui/scripts/curve.tcl
===================================================================
--- trunk/gui/scripts/curve.tcl	(revision 6716)
+++ trunk/gui/scripts/curve.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: curve - extracts data from an XML description of a field
@@ -10,44 +9,27 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itcl
 package require BLT
 
-namespace eval Rappture {
-    # forward declaration
-}
+namespace eval Rappture { # forward declaration }
 
 itcl::class Rappture::Curve {
-    constructor {xmlobj path} {
-        # defined below
-    }
-    destructor {
-        # defined below
-    }
+    constructor {libobj path} { # defined below }
+    destructor { # defined below }
 
     public method components {{pattern *}}
-    public method mesh {cname }
-    public method values { cname }
-    public method limits {which}
+    public method vectors {{what -overall}}
+    public method controls {option args}
     public method hints {{key ""}}
-    public method xmarkers {}
-    public method ymarkers {}
-    public method xErrorValues { cname }
-    public method yErrorValues { cname }
 
     protected method _build {}
 
-    private variable _xmlobj ""  ;      # ref to lib obj with curve data
-    private variable _curve ""   ;      # lib obj representing this curve
-    private variable _comp2xy    ;      # maps component name => x,y vectors
-    private variable _hints      ;      # cache of hints stored in XML
+    private variable _libobj ""  ;# ref to lib obj with curve data
+    private variable _curve ""   ;# lib obj representing this curve
+    private variable _comp2vecs  ;# maps component name => x,y vectors
 
-    private variable _xmarkers "";      # list of {x,label,options} triplets.
-    private variable _ymarkers "";      # list of {y,label,options} triplets.
-    private common _counter 0    ;      # counter for unique vector names
+    private common _counter 0    ;# counter for unique vector names
 }
 
@@ -55,10 +37,11 @@
 # CONSTRUCTOR
 # ----------------------------------------------------------------------
-itcl::body Rappture::Curve::constructor {xmlobj path} {
-    if {![Rappture::library isvalid $xmlobj]} {
-        error "bad value \"$xmlobj\": should be LibraryObj"
+itcl::body Rappture::Curve::constructor {libobj path} {
+    if {![Rappture::Library::valid $libobj]} {
+        error "bad value \"$libobj\": should be LibraryObj"
     }
-    set _xmlobj $xmlobj
-    set _curve [$xmlobj element -as object $path]
+    set _libobj $libobj
+    set _curve [$libobj get -object $path]
+
     # build up vectors for various components of the curve
     _build
@@ -70,8 +53,8 @@
 itcl::body Rappture::Curve::destructor {} {
     itcl::delete object $_curve
-    # don't destroy the _xmlobj! we don't own it!
+    # don't destroy the _libobj! we don't own it!
 
-    foreach name [array names _comp2xy] {
-        eval blt::vector destroy $_comp2xy($name)
+    foreach name [array names _comp2vecs] {
+        eval blt::vector destroy $_comp2vecs($name)
     }
 }
@@ -86,5 +69,5 @@
 itcl::body Rappture::Curve::components {{pattern *}} {
     set rlist ""
-    foreach name [array names _comp2xy] {
+    foreach name [array names _comp2vecs] {
         if {[string match $pattern $name]} {
             lappend rlist $name
@@ -95,126 +78,15 @@
 
 # ----------------------------------------------------------------------
-# USAGE: mesh ?<name>?
+# USAGE: vectors ?<name>?
 #
-# Returns the xvec for the specified curve component <name>.
+# Returns a list {xvec yvec} for the specified curve component <name>.
 # If the name is not specified, then it returns the vectors for the
 # overall curve (sum of all components).
 # ----------------------------------------------------------------------
-itcl::body Rappture::Curve::mesh {cname} {
-    if {[info exists _comp2xy($cname)]} {
-        return [lindex $_comp2xy($cname) 0]  ;# return xv
+itcl::body Rappture::Curve::vectors {{what -overall}} {
+    if {[info exists _comp2vecs($what)]} {
+        return $_comp2vecs($what)
     }
-    error "bad component \"$cname\": should be one of [join [lsort [array names _comp2xy]] {, }]"
-}
-
-# ----------------------------------------------------------------------
-# USAGE: values ?<name>?
-#
-# Returns the yvec for the specified curve component <name>.
-# If the name is not specified, then it returns the vectors for the
-# overall curve (sum of all components).
-# ----------------------------------------------------------------------
-itcl::body Rappture::Curve::values {cname} {
-    if {[info exists _comp2xy($cname)]} {
-        return [lindex $_comp2xy($cname) 1]  ;# return yv
-    }
-    error "bad component \"$cname\": should be one of [join [lsort [array names _comp2xy]] {, }]"
-}
-
-# ----------------------------------------------------------------------
-# USAGE: xErrorValues <name>
-#
-# Returns the xvec for the specified curve component <name>.
-# If the name is not specified, then it returns the vectors for the
-# overall curve (sum of all components).
-# ----------------------------------------------------------------------
-itcl::body Rappture::Curve::xErrorValues { cname } {
-    if {[info exists _comp2xy($cname)]} {
-        return [lindex $_comp2xy($cname) 2]  ;# return xev
-    }
-    error "unknown component \"$cname\": should be one of [join [lsort [array names _comp2xy]] {, }]"
-}
-
-# ----------------------------------------------------------------------
-# USAGE: yErrorValues <name>
-#
-# Returns the xvec for the specified curve component <name>.
-# If the name is not specified, then it returns the vectors for the
-# overall curve (sum of all components).
-# ----------------------------------------------------------------------
-itcl::body Rappture::Curve::yErrorValues { cname } {
-    if {[info exists _comp2xy($cname)]} {
-        return [lindex $_comp2xy($cname) 3]  ;# return yev
-    }
-    error "unknown component \"$cname\": should be one of [join [lsort [array names _comp2xy]] {, }]"
-}
-
-# ----------------------------------------------------------------------
-# USAGE: limits x|xlin|xlog|y|ylin|ylog
-#
-# Returns the {min max} limits for the specified axis.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Curve::limits {which} {
-    set min ""
-    set max ""
-    switch -- $which {
-        x - xlin { set pos 0; set log 0; set axis xaxis }
-        xlog { set pos 0; set log 1; set axis xaxis }
-        y - ylin - v - vlin { set pos 1; set log 0; set axis yaxis }
-        ylog - vlog { set pos 1; set log 1; set axis yaxis }
-        default {
-            error "bad option \"$which\": should be x, xlin, xlog, y, ylin, ylog, v, vlin, vlog"
-        }
-    }
-
-    blt::vector tmp zero
-    foreach comp [array names _comp2xy] {
-        set vname [lindex $_comp2xy($comp) $pos]
-        $vname variable vec
-
-        if {$log} {
-            # on a log scale, use abs value and ignore 0's
-            $vname dup tmp
-            $vname dup zero
-            zero expr {tmp == 0}            ;# find the 0's
-            tmp expr {abs(tmp)}             ;# get the abs value
-            tmp expr {tmp + zero*max(tmp)}  ;# replace 0's with abs max
-            set vmin [blt::vector expr min(tmp)]
-            set vmax [blt::vector expr max(tmp)]
-        } else {
-            set vmin $vec(min)
-            set vmax $vec(max)
-        }
-
-        if {"" == $min} {
-            set min $vmin
-        } elseif {$vmin < $min} {
-            set min $vmin
-        }
-        if {"" == $max} {
-            set max $vmax
-        } elseif {$vmax > $max} {
-            set max $vmax
-        }
-    }
-    blt::vector destroy tmp zero
-
-    set val [$_curve get $axis.min]
-    if {"" != $val && "" != $min} {
-        if {$val > $min} {
-            # tool specified this min -- don't go any lower
-            set min $val
-        }
-    }
-
-    set val [$_curve get $axis.max]
-    if {"" != $val && "" != $max} {
-        if {$val < $max} {
-            # tool specified this max -- don't go any higher
-            set max $val
-        }
-    }
-
-    return [list $min $max]
+    error "bad option \"$what\": should be [join [lsort [array names _comp2vecs]] {, }]"
 }
 
@@ -227,53 +99,28 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Curve::hints {{keyword ""}} {
-    if {![info exists _hints]} {
-        foreach {key path} {
-            color   about.color
-            group   about.group
-            label   about.label
-            style   about.style
-            type    about.type
-            xdesc   xaxis.description
-            xlabel  xaxis.label
-            xmax    xaxis.max
-            xmin    xaxis.min
-            xscale  xaxis.scale
-            xticks  xaxis.ticklabels
-            xunits  xaxis.units
-            ydesc   yaxis.description
-            ylabel  yaxis.label
-            ymax    yaxis.max
-            ymin    yaxis.min
-            yscale  yaxis.scale
-            yticks  yaxis.ticklabels
-            yunits  yaxis.units
-        } {
-            set str [$_curve get $path]
-            if {"" != $str} {
-                set _hints($key) $str
-            }
+    foreach {key path} {
+        label   label
+        color   color
+        color   style
+        xlabel  xaxis.label
+        xunits  xaxis.units
+        xscale  xaxis.scale
+        ylabel  yaxis.label
+        yunits  yaxis.units
+        yscale  yaxis.scale
+    } {
+        set str [$_curve get $path]
+        if {"" != $str} {
+            set hints($key) $str
         }
-        if {[info exists _hints(xlabel)] && "" != $_hints(xlabel)
-              && [info exists _hints(xunits)] && "" != $_hints(xunits)} {
-            set _hints(xlabel) "$_hints(xlabel) ($_hints(xunits))"
-        }
-        if {[info exists _hints(ylabel)] && "" != $_hints(ylabel)
-              && [info exists _hints(yunits)] && "" != $_hints(yunits)} {
-            set _hints(ylabel) "$_hints(ylabel) ($_hints(yunits))"
-        }
+    }
 
-        if {[info exists _hints(group)] && [info exists _hints(label)]} {
-            # pop-up help for each curve
-            set _hints(tooltip) $_hints(label)
-        }
-        set _hints(xmlobj) $_xmlobj
-    }
     if {$keyword != ""} {
-        if {[info exists _hints($keyword)]} {
-            return $_hints($keyword)
+        if {[info exists hints($keyword)]} {
+            return $hints($keyword)
         }
         return ""
     }
-    return [array get _hints]
+    return [array get hints]
 }
 
@@ -288,8 +135,8 @@
 itcl::body Rappture::Curve::_build {} {
     # discard any existing data
-    foreach name [array names _comp2xy] {
-        eval blt::vector destroy $_comp2xy($name)
+    foreach name [array names _comp2vecs] {
+        eval blt::vector destroy $_comp2vecs($name)
     }
-    catch {unset _comp2xy}
+    catch {unset _comp2vecs}
 
     #
@@ -297,70 +144,26 @@
     # vectors for each part.
     #
-    foreach cname [$_curve children -type component] {
-        set xv [blt::vector create \#auto]
-        set yv [blt::vector create \#auto]
-        set xev [blt::vector create \#auto]
-        set yev [blt::vector create \#auto]
+    set max [$_curve get -count component]
+    for {set i 0} {$i < $max} {incr i} {
+        set xv ""
+        set yv ""
 
-        set xydata [$_curve get $cname.xy]
-        if { "" != $xydata} {
-            set tmp [blt::vector create \#auto]
-            $tmp set $xydata
-            $tmp split $xv $yv
-            blt::vector destroy $tmp
-        } else {
-            $xv set [$_curve get $cname.xvector]
-            $yv set [$_curve get $cname.yvector]
+        set xydata [$_curve get component$i.xy]
+        if {"" != $xydata} {
+            set xv [blt::vector create x$_counter]
+            set yv [blt::vector create y$_counter]
+
+            foreach line [split $xydata \n] {
+                if {[scan $line {%g %g} xval yval] == 2} {
+                    $xv append $xval
+                    $yv append $yval
+                }
+            }
         }
-        if { (([$xv length] == 0) && ([$yv length] == 0)) ||
-             ([$xv length] != [$yv length]) } {
-            # FIXME: need to show an error about improper data.
-            blt::vector destroy $xv $yv
-            set xv ""; set yv ""
-            continue;
+
+        if {$xv != "" && $yv != ""} {
+            set _comp2vecs(component$i) [list $xv $yv]
+            incr _counter
         }
-        $xev set [$_curve get "$cname.xerrorbars"]
-        $yev set [$_curve get "$cname.yerrorbars"]
-        set _comp2xy($cname) [list $xv $yv $xev $yev]
-        incr _counter
-    }
-
-    # Creates lists of x and y marker data.
-    set _xmarkers {}
-    set _ymarkers {}
-    foreach cname [$_curve children -type "marker" xaxis] {
-        set at     [$_curve get "xaxis.$cname.at"]
-        set label  [$_curve get "xaxis.$cname.label"]
-        set styles [$_curve get "xaxis.$cname.style"]
-        set data [list $at $label $styles]
-        lappend _xmarkers $data
-    }
-    foreach cname [$_curve children -type "marker" yaxis] {
-        set at     [$_curve get "yaxis.$cname.at"]
-        set label  [$_curve get "yaxis.$cname.label"]
-        set styles [$_curve get "yaxis.$cname.style"]
-        set data [list $at $label $styles]
-        lappend _ymarkers $data
     }
 }
-
-# ----------------------------------------------------------------------
-# USAGE: xmarkers
-#
-# Returns the list of settings for each marker on the x-axis.
-# If no markers have been specified the empty string is returned.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Curve::xmarkers {} {
-    return $_xmarkers;
-}
-
-# ----------------------------------------------------------------------
-# USAGE: ymarkers
-#
-# Returns the list of settings for each marker on the y-axis.
-# If no markers have been specified the empty string is returned.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Curve::ymarkers {} {
-    return $_ymarkers;
-}
-
